///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//////
//////
////// M A I N
//////
//////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

THE_TOP_ITEMS = ['00','01','02','03','04','05','06'];

theContentManager = new ContentManager();
theTopmenuManager = new TopmenuManager();
theFichasPathmenuManager = new FichasPathmenuManager();
theSupermenuManager = new SupermenuManager();
theSubmenuManager = new SubmenuManager();

theContentManager.setTopmenuManager(parent.parent.theTopmenuManager);
theContentManager.setSupermenuManager(parent.parent.theSupermenuManager);

theTopmenuManager.setItems(THE_TOP_ITEMS);
theTopmenuManager.setSupermenuManager(theSupermenuManager);

theSupermenuManager.setTopmenuManager(parent.theTopmenuManager);

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//////
//////
////// C O N T E N T
//////
//////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

/**
 * Controla os behaviors dos menus ao carregar uma pgina content.
 *
 * @author Eldes de Paula (eldes@eldes.com)
 */
function ContentManager() {

  var theTopmenuManager = null;
  var theSupermenuManager = null
  
  this.setTopmenuManager = function(aManager) {
    this.theTopmenuManager = aManager;
	}
	
  this.setSupermenuManager = function(aManager) {
    this.theSupermenuManager = aManager;
    }
	
  this.onMouseOver = function(aDocument) {
	    parent.parent.theSupermenuManager.onMouseOutMenu(parent.parent.supermenu_layer_01);
	parent.parent.theSupermenuManager.onMouseOutMenu(parent.parent.supermenu_layer_02);
	parent.parent.theSupermenuManager.onMouseOutMenu(parent.parent.supermenu_layer_03);
	parent.parent.theSupermenuManager.onMouseOutMenu(parent.parent.supermenu_layer_04);
	parent.parent.theSupermenuManager.onMouseOutMenu(parent.parent.supermenu_layer_05);
	parent.parent.theSupermenuManager.onMouseOutMenu(parent.parent.supermenu_layer_06);
  }
  
  this.onLoad = function(aDocument) {
    parent.parent.theSupermenuManager.onMouseOutMenu(parent.parent.supermenu_layer_01);
	parent.parent.theSupermenuManager.onMouseOutMenu(parent.parent.supermenu_layer_02);
	parent.parent.theSupermenuManager.onMouseOutMenu(parent.parent.supermenu_layer_03);
	parent.parent.theSupermenuManager.onMouseOutMenu(parent.parent.supermenu_layer_04);
	parent.parent.theSupermenuManager.onMouseOutMenu(parent.parent.supermenu_layer_05);
	parent.parent.theSupermenuManager.onMouseOutMenu(parent.parent.supermenu_layer_06);
	
    myUrlSlices = aDocument.URL.split("\\");
	myFilename = myUrlSlices[myUrlSlices.length - 1];
	myFilenameWithoutExtension = myFilename.split(".")[0];
	myItem = myFilenameWithoutExtension.split("_")[0];
	
	myTopItem = myItem.substr(0,2);
	this.theTopmenuManager.selectItem(myTopItem);
    parent.parent.supermenu_frame_01.theSupermenuManager.selectItem("");
    parent.parent.supermenu_frame_02.theSupermenuManager.selectItem("");
	parent.parent.supermenu_frame_03.theSupermenuManager.selectItem("");
	parent.parent.supermenu_frame_04.theSupermenuManager.selectItem("");
	parent.parent.supermenu_frame_05.theSupermenuManager.selectItem("");
	parent.parent.supermenu_frame_06.theSupermenuManager.selectItem("");
	
	if (myItem.length >= 4) {
	  mySuperItem = myTopItem + "_" + myItem.substr(2,2);
	  parent.parent.supermenu_frame_01.theSupermenuManager.selectItem(mySuperItem);
	  parent.parent.supermenu_frame_02.theSupermenuManager.selectItem(mySuperItem);
	  parent.parent.supermenu_frame_03.theSupermenuManager.selectItem(mySuperItem);
	  parent.parent.supermenu_frame_04.theSupermenuManager.selectItem(mySuperItem);
	  parent.parent.supermenu_frame_05.theSupermenuManager.selectItem(mySuperItem);
	  parent.parent.supermenu_frame_06.theSupermenuManager.selectItem(mySuperItem);
	}
	
	if (myItem.length >= 6) {
	  mySubItem = mySuperItem + "_" + myItem.substr(4,2);
	  parent.submenu.theSubmenuManager.selectItem(mySubItem);
	}
	
	if (myItem.length >= 8) {
	  mySubSubitem = mySubItem + "_" + myItem.substr(6,2);
	  parent.submenu.theSubmenuManager.selectSubitem(mySubSubitem);
	}
  }
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//////
//////
////// T O P M E N U
//////
//////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

/**
 * Controla os behaviors do topmenu (menu principal).
 *
 * @author Eldes de Paula (eldes@eldes.com)
 */
function TopmenuManager() {

  /**
   * String contendo o identificador do item selecionado no topmenu.
   */
  var theSelectedItem = null;

  /**
   * Objeto da classe SupermenuManager usado para controlar os supermenus
   * correspondentes aos itens do topmenu.
   */
  var theSupermenuManager = null;
  
  /**
   * Array com todos os itens do topmenu.
   */
  var theItems = null;

  /////////////////////////////////////////////////////////////////////////////
  //
  // SET ITEMS
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Define o array com a lista de itens do topmenu.
   */
  this.setItems = function(aItems) {
    this.theItems = aItems;
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // SET SUPERMENU MANAGER
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Define o supermenu manager.
   */
  this.setSupermenuManager = function(aSupermenuManager) {
    this.theSupermenuManager = aSupermenuManager;
  }
  
  this.selectItem = function(aItem) {
    this.highlightOff(this.theSelectedItem);
    this.theSelectedItem = aItem
	this.highlightOn(aItem)
    }
  
  /////////////////////////////////////////////////////////////////////////////
  //
  // HIGHLIGHT ON
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Acende um item do topmenu.
   */
  this.highlightOn = function(aItem) {
    try {
	  myImage = this.getImageByItem(aItem);
      myImage.src = 'comum/topmenu_' + aItem + '_on.gif';
	}
	catch(e) {
	  return;
	}
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // HIGHLIGHT OFF
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Apaga um item do topmenu.
   */
  this.highlightOff = function(aItem) {
    try {
      myImage = this.getImageByItem(aItem);
      myImage.src = 'comum/topmenu_' + aItem + '_off.gif';
	}
	catch (e) {
	  return;
	}
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // HIGHLIGHT OFF ALL
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Apaga todos os itens do topmenu.
   */
  this.highlightOffAll = function() {
    for (i = 0; i < this.theItems.length; i++)
      this.highlightOff(this.theItems[i]);
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // SHOW SUPERMENU
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Mostra o respectivo supermenu de um item do topmenu.
   */
  
  this.showSupermenu = function(aItem) {
    this.theSupermenuManager.show(aItem);
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // HIDE SUPERMENU
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Esconde o respectivo supermenu de um item do topmenu.
   */
  
  this.hideSupermenu = function(aItem) {
    this.theSupermenuManager.hide(aItem);
  }
  
  this.hideSupermenuAll = function() {
    for (i = 0; i < this.theItems.length; i++)
	  this.hideSupermenu(this.theItems[i]);
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // HIDE SUPERMENU ALL
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Esconde os supermenus de todos os itens do topmenu.
   */
  
  this.hideSupermenuAll = function() {
    for (i = 0; i < this.theItems.length; i++)
      this.hideSupermenu(this.theItems[i]);
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // ON MOUSE OVER
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Acende um item do topmenu e abre seu supermenu correspondente; e apaga
   * o item vizinho, caso o vizinho no seja o item selecionado do topmenu.
   */
  this.onMouseOver = function(aLink) {
    myItem = this.getItemByLink(aLink);
	this.highlightOn(myItem);
	this.hideSupermenuAll();
    this.showSupermenu(myItem);
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // ON MOUSE OUT
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Apaga um item do topmenu e fecha.
   */
  this.onMouseOut = function(aLink) {
    myItem = this.getItemByLink(aLink);
	if (this.theSelectedItem != myItem)
	  this.highlightOff(myItem);
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // ON MOUSE UP
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Seleciona este novo item e deseleciona o anterior do topmenu e menus????
   */
  this.onMouseUp = function(aLink) {
    //No faz nada. O boto do topmenu  selecionado por meio de uma ao do
	//evento de onLoad da pgina correspondente.
	return true;
  }
   
  /////////////////////////////////////////////////////////////////////////////
  //
  // GET ITEM BY LINK
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Retorna o item do link do topmenu item especificado.
   *
   * O id do link tem o seguinte formato: 'topmenu_link_99'; e o item retornado
   * tem o seguinte formato: '99'.
   */
  this.getItemByLink = function(aLink) {
    return aLink == null ? '' : aLink.id.substr(13,2);
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // GET IMAGE BY ITEM
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Retorna o objeto imagem do topmenu item especificado.
   *
   * O item especificado tem o seguinte formato: '99'.
   */
  this.getImageByItem = function(aItem) {
    return document.images['topmenu_image_' + aItem];
  }
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//////
//////
////// F I C H A S   P A T H   M E N U
//////
//////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

function FichasPathmenuManager() {

  this.onMouseOver = function(aLink) {
    var myItem = this.getItemByLink(aLink);
	this.highlightOn(myItem);
  }
  
  this.onMouseOut = function(aLink) {
    var myItem = this.getItemByLink(aLink);
	this.highlightOff(myItem);
  }
  
  this.highlightOn = function(aItem) {
    this.getImageByItem(aItem).src = 'pathmenu_' + aItem + '_on.gif';
  }
  
  this.highlightOff = function(aItem) {
    this.getImageByItem(aItem).src = 'pathmenu_' + aItem + '_off.gif';
  }
  
  this.highlightOff = function(aItem) {
    this.getImageByItem(aItem).src = 'pathmenu_' + aItem + '_off.gif';
  }
  
  this.getItemByLink = function(aLink) {
    return aLink.id.substr(14,5);
  }
  
  this.getImageByItem = function(aItem) {
    return document.images['pathmenu_image_' + aItem];
  }
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//////
//////
////// S U P E R M E N U
//////
//////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

function SupermenuManager() {

  var theSelectedItem = null;
  var theTopmenuManager = null;
  
  this.setTopmenuManager = function(aTopmenuManager) {
    this.theTopmenuManager = aTopmenuManager;
  }
  
  this.highlightOnTopmenu = function(aItem) {
    this.theTopmenuManager.highlightOn(aItem);
  }
  
  this.highlightOffTopmenu = function(aItem) {
    this.theTopmenuManager.highlightOff(aItem);
  }
  
  this.selectItem = function(aItem) {
    this.highlightOff(this.theSelectedItem);
    this.theSelectedItem = aItem;
	this.highlightOn(aItem);
  }
    
  /////////////////////////////////////////////////////////////////////////////
  //
  // ON MOUSE OVER
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Acende um item do supermenu.
   */  
  this.onMouseOver = function(aObject) {
    if (this.isItem(aObject))
	  this.onMouseOverItem(aObject);
	  
	else if (this.isMenu(aObject))
	  this.onMouseOverMenu(aObject);
  }
  
  this.onMouseOverItem = function(aLink) {
    myItem = this.getItemByLink(aLink);
	this.highlightOn(myItem);
	this.highlightOnTopmenu(myItem);
  }
  
  this.onMouseOverMenu = function(aLayer) {
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // ON MOUSE OUT
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Apaga um item do supermenu.
   */  
  this.onMouseOut = function(aObject) {
    if (this.isItem(aObject))
	  this.onMouseOutItem(aObject);
	  
	else if (this.isMenu(aObject))
	  this.onMouseOutMenu(aObject);
  }

  this.onMouseOutItem = function(aLink) {
    myItem = this.getItemByLink(aLink);
	if (myItem != this.theSelectedItem)
	  this.highlightOff(myItem);
	
	myTopItem = myItem.substr(0,2);
	if (myTopItem != this.theTopmenuManager.theSelectedItem)
	  this.highlightOffTopmenu(myTopItem);
  }
  
  this.onMouseOutMenu = function(aLayer) {
    aLayer.style.visibility = "hidden";
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // SHOW
  //
  /////////////////////////////////////////////////////////////////////////////
  
  /**
   * Mostra o layer do supermenu.
   */
  this.show = function(aItem) {
    myLayer = document.getElementById('supermenu_layer_' + aItem);
    if (myLayer) {
      myLayer.style.visibility = 'visible';
	  this.highlightOn(this.theSelectedItem);//??????????????????????????????
	}
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // HIDE
  //
  /////////////////////////////////////////////////////////////////////////////
  
  /**
   * Esconde o layer do supermenu.
   */
  this.hide = function(aItem,aWindow) {
    if (aWindow == null)
	  aWindow = window
	  
    myLayer = aWindow.document.getElementById('supermenu_layer_' + aItem);
	if (myLayer)
	  myLayer.style.visibility = 'hidden';
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // HIGHLIGHT ON
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Acende um item do supermenu.
   */
  this.highlightOn = function(aItem) {
    try {
      myImage = this.getImageByItem(aItem);
      myImage.src = 'supermenu_' + aItem + '_on.gif';
	}
	catch (e) {
	  return;
	}
  } 
  
  /////////////////////////////////////////////////////////////////////////////
  //
  // HIGHLIGHT OFF
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Apaga um item do supermenu.
   */
  this.highlightOff = function(aItem) {
    try {
      myImage = this.getImageByItem(aItem);
      myImage.src = 'supermenu_' + aItem + '_off.gif';
	}
	catch (e) {
	  return;
	}
  }
  
  //////////////////////////////////////////////////////////////////////////////
  
  this.highlightOnTopmenu = function(myItem) {
    this.theTopmenuManager.highlightOn(myItem.substr(0,2));
  }
  
  //////////////////////////////////////////////////////////////////////////////
  
  this.highlightOffTopmenu = function(myItem) {
    if (this.theTopmenuManager.theSelectedItem != myItem)
      this.theTopmenuManager.highlightOff(myItem.substr(0,2));
  }
 
  /////////////////////////////////////////////////////////////////////////////
  //
  // GET ITEM BY LAYER
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Retorna o item do layer do supermenu especificado.
   *
   * O id do layer tem o seguinte formato: 'supermenu_layer_99'; e o item retornado
   * tem o seguinte formato: '99'.
   */
  this.getItemByLayer = function(aLayer) {
    return aLayer.id.substr(14,2);
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // GET ITEM BY LINK
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Retorna o item do link do item do supermenu especificado.
   *
   * O id do link tem o seguinte formato: 'supermenu_link_99_99'; e o item
   * retornado tem o seguinte formato: '99_99'.
   */
  this.getItemByLink = function(aLink) {
    return aLink.id.substr(15,5);
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // GET IMAGE BY ITEM
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Retorna o objeto imagem do supermenu item especificado.
   *
   * O item especificado tem o seguinte formato: '99_99'.
   */
  this.getImageByItem = function(aItem) {
    return document.images['supermenu_image_' + aItem];
  }
  
  this.isItem = function(aObject) {
    return (aObject.id.substr(10,4).toUpperCase() == 'LINK');
  }
  
  this.isMenu = function(aObject) {
    return (aObject.id.substr(10,5).toUpperCase() == 'LAYER');
  }
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//////
//////
////// S U B M E N U
//////
//////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

function SubmenuManager() {

  /**
   * String contendo o identificador do item selecionado no submenu no formato
   * "99_99_99".
   */
  var theSelectedItem = null;

  /**
   * String contendo o identificador do subitem selecionado no submenu no
   * formato "99_99_99".
   */
  var theSelectedSubitem = null;
  
  this.selectItem = function(aItem) {
    this.highlightOff(this.theSelectedItem);
	this.theSelectedItem = aItem
	this.highlightOn(aItem);
  }
  
  this.selectSubitem = function(aItem) {
    myLink = this.getLinkBySubitem(this.theSelectedSubitem);
	if (myLink != null)
      this.subHighlightOff(myLink);
	this.theSelectedSubitem = aItem
	myLink = this.getLinkBySubitem(aItem);
	if (myLink != null)
	  this.subHighlightOn(myLink);
  }
  
  /////////////////////////////////////////////////////////////////////////////
  //
  // ON MOUSE OVER
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Acende um item do submenu.
   */  
  this.onMouseOver = function(aLink) {
    myItem = this.getItemByLink(aLink);
	this.highlightOn(myItem);
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // ON MOUSE OUT
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Apaga um item do submenu.
   */  
  this.onMouseOut = function(aLink) {
    myItem = this.getItemByLink(aLink);
	if (myItem != this.theSelectedItem)
	  this.highlightOff(myItem);
  }
  
  /////////////////////////////////////////////////////////////////////////////
  //
  // SUB ON MOUSE OVER
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Acende um subitem do submenu.
   */  
  this.subOnMouseOver = function(aLink) {
	this.subHighlightOn(aLink);
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // SUB ON MOUSE OUT
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Apaga um subitem do submenu.
   */  
  this.subOnMouseOut = function(aLink) {
    mySubitem = this.getSubitemByLink(aLink);
	if (mySubitem != this.theSelectedSubitem)
	  this.subHighlightOff(aLink);
  }
  
  /////////////////////////////////////////////////////////////////////////////
  //
  // HIGHLIGHT ON
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Acende um item do submenu.
   */
  this.highlightOn = function(aItem) {
    try {
      myImage = this.getImageByItem(aItem);
      myImage.src = 'submenu_' + aItem + '_on.gif';
	}
	catch (e) {
	  return;
	}
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // HIGHLIGHT OFF
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Apaga um item do submenu.
   */
  this.highlightOff = function(aItem) {
    try {
      myImage = this.getImageByItem(aItem);
      myImage.src = 'submenu_' + aItem + '_off.gif';
	}
	catch (e) {
	  return;
	}
  } 
  
  /////////////////////////////////////////////////////////////////////////////
  //
  // SUB HIGHLIGHT ON
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Acende um subitem do submenu.
   */  
  this.subHighlightOn = function(aLink) {
    aLink.style.color = '#F00';
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // SUB HIGHLIGHT OFF
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Apaga um subitem do submenu.
   */  
  this.subHighlightOff = function(aLink) {
    aLink.style.color = '#000';
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // GET ITEM BY LINK
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Retorna o item do link do item do submenu especificado.
   *
   * O id do link tem o seguinte formato: 'submenu_link_99_99_99'; e o item
   * retornado tem o seguinte formato: '99_99_99'.
   */
  this.getItemByLink = function(aLink) {
    return aLink.id.substr(13,8);
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // GET IMAGE BY ITEM
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Retorna o objeto imagem do submenu item especificado.
   *
   * O item especificado tem o seguinte formato: '99_99_99'.
   */
  this.getImageByItem = function(aItem) {
    return document.images['submenu_image_' + aItem];
  }

  /////////////////////////////////////////////////////////////////////////////
  //
  // GET SUB ITEM BY LINK
  //
  /////////////////////////////////////////////////////////////////////////////

  /**
   * Retorna o subitem do link do item do submenu especificado.
   *
   * O id do link tem o seguinte formato: 'submenu_link_99_99_99_99'; e o
   * subitem retornado tem o seguinte formato: '99_99_99_99'.
   */
  this.getSubitemByLink = function(aLink) {
    return aLink.id.substr(13,11);
  }
  
  this.getLinkBySubitem = function(aItem) {
    return document.getElementById("submenu_link_" + aItem);
  }
  }